/**************************************
 * NOTE: This source code is free and 
 * comes with ABSOLUTELY NO WARRANTY.
 * 
 * @author Daniel Muenter, 2006
 * 
 **************************************/

var FbfTree = {
	
	// A table is a 2D array
	datatable : new Array(),
	dtbackup : new Array(),
	currentTable : null,
	tree : null,
	sorted : false,
	filter : 'none',

	// colName:[index, order, isnumber]
	datacols : {
		type 	: [ 0, 0, 0 ],
		comment : [ 1, 0, 0 ],
		left 	: [ 2, 0, 0 ],
		date 	: [ 3, 0, 0 ],
		item 	: [ 4, 0, 0 ]
	},
	rowcount : 0,

	addItem: function(item) {
		if (this.tree == null) {
			this.initTreeView();
		}
		this.datatable.push(item);
		this.dtbackup.push(item);
		this.rowcount++;
		if (this.sorted) {
			var column = document.getElementById('type');
			this.sortcolumn(column);
		} else if (this.filter != 'none') {
			this.filterByType(this.filter);
		} else {
			this.tree.view = new FbfTreeView(this.datatable, this.datacols, this.rowcount);
			this.currentTable = this.datatable;
		}
	},

	getDataTable: function() {
		return this.currentTable;
	},

	resetTree: function() {
		this.datatable = new Array();
		this.dtbackup = new Array();
		this.rowcount = 0;
		if (this.tree) {
			this.tree.view = new FbfTreeView(this.datatable, this.datacols, this.rowcount);
		}
		this.currentTable = this.datatable;
		this.sorted = false;
		this.filter = 'none';
	},

	initTreeView: function() {
		this.tree = document.getElementById('list');
		this.tree.view = new FbfTreeView(this.datatable, this.datacols, this.rowcount);
		this.currentTable = this.datatable;
	},

	showAll: function() {
		this.tree.view = new FbfTreeView(this.dtbackup, this.datacols, this.rowcount);
		this.currentTable = this.dtbackup;
	},

	filterByType: function(type) {
		this.filter = type;
		var count = 0;
		var filtered = new Array();
		for ( var i = 0; i < this.datatable.length; i++) {
			if (this.datatable[i][0] == type) {
				filtered.push(this.datatable[i]);
				count++;
			}
		}
		this.tree.view = new FbfTreeView(filtered, this.datacols, count);
		this.currentTable = filtered;
	},

	// This function will be called everytime we click on a column header
	sortcolumn: function(column) {
		var name = column.getAttribute("id");
		var index = this.datacols[name][0];
		var order = 0;
		var isnum = true;
		this.tableSort(this.datatable, index, order, false); // sort the table
		this.tree.view = new FbfTreeView(this.datatable, this.datacols, this.rowcount); // bind to tree
		this.currentTable = this.datatable;
		this.sorted = true;
	},

	// This is the actual sorting method, extending the array.sort() method
	tableSort: function(table, col, order, isnum) {
		col = 6; // insures only sort by comment type
		function columnSort(a, b) {
			return (a[col] - b[col]);
		}
		// use array.sort(comparer) method
		table.sort(columnSort);
	}
};


// This is our custom view, based on the treeview interface
function FbfTreeView(table, columns, rowcount) {

	this.atomService = Components.classes["@mozilla.org/atom-service;1"]
			.getService(Components.interfaces.nsIAtomService);
	this.table = table; // our table
	this.columns = columns; // our cols
	this.rowCount = rowcount; // our counter
	this.setTree = function(treebox) {
		this.treebox = treebox;
	};
	this.isContainer = function(row) {
		return false;
	};
	this.isSeparator = function(row) {
		return false;
	};
	this.isSorted = function(row) {
		return false;
	};
	this.getLevel = function(row) {
		return 0;
	};
	this.getImageSrc = function(row, col) {
		return null;
	};
	this.cycleHeader = function(col) {
	};
	this.getCellProperties = function(row, col, props) {
	};
	this.getColumnProperties = function(col, properties) {
	};

	this.getRowProperties = function(row, properties) {

		if (this.table[row][0] == "negative") {
			properties.AppendElement(this.atomService.getAtom("negative"));
		} else if (this.table[row][0] == "neutral") {
			properties.AppendElement(this.atomService.getAtom("neutral"));
		} else if (this.table[row][0] == "positive") {
			properties.AppendElement(this.atomService.getAtom("positive"));
		} else if (this.table[row][0] == "withdrawn") {
			properties.AppendElement(this.atomService.getAtom("withdrawn"));
		}
	};

	this.getCellText = function(row, column) {
		return this.table[row][this.columns[column.id][0]];
	};
}

